/****************************************************************************
**
** Copyright (C) 2013 Atmel Corporation and/or its subsidiary(-ies).
** All rights reserved.
**
** LIMITED License Agreement
**
** IT IS IMPORTANT THAT YOU READ THIS AGREEMENT CAREFULLY AND COMPLETELY.
** This Limited License Agreement (“Agreement”) is a legally binding agreement between,
** on one hand, either your employer (if you are acting on behalf of your employer)
** or you (if you are acting on your own behalf) (“Licensee”), and on the other hand,
** Atmel Corporation (“Atmel”).
**
** By installing or using any of the software downloaded or provided with these
** terms (“Licensed Software”), you are indicating that you are binding Licensee
** to the terms of this Agreement, and that you are duly authorized by Licensee to do so.
** If you are not authorized to bind Licensee to the terms of this Agreement,
** or if Licensee does not agree to be bound by all of the terms of this Agreement,
** do not install or use any such software.
**
**
** 1.	Grant of License.  Subject to the terms and conditions of this Agreement,
** Atmel grants Licensee a non-exclusive, non-transferable, non-sublicensable,
** limited license to use the Licensed Software solely in connection with Atmel products
** from SAM9 and SAMA5 families (“Atmel Product”).
**
** 2.	Restrictions.  Except as expressly set forth in Section 1, Licensee will not,
** and will have no right to, (a) use, copy or reproduce any Licensed Software except,
** (b) modify, create derivative works of, sell, distribute, transfer or disclose any
** Licensed Software. Without limiting the generality of the foregoing, Licensee will not,
** and will have no right to, use any Licensed Software for any semiconductor products
** that are not Atmel Products. Licensee will not remove, obscure or alter any trademark,
** copyright or other proprietary rights or ownership notices of Atmel that appear
** in any Licensed Software.
**
** 3.  	Title.  As between the parties, Atmel retains full rights, title, and ownership
** including all patents, copyrights, trade secrets, trade names, trademarks, and other
** intellectual property rights in and to the Licensed Software.
**
** 4.  	No Other Rights.  Except as expressly stated herein, this Agreement does not grant
** Licensee any rights to patents, copyrights, trade secrets, trade names, trademarks
** (whether registered or unregistered), or any other rights, franchises, or licenses
** in respect of the Licensed Software.
**
** 5.	Disclaimer of Warranty and No Support.  ALL LICENSED SOFTWARE IS PROVIDED “AS IS”,
** “WITH ALL FAULTS”, AND WITH NO WARRANTY WHATSOEVER.  ATMEL EXPRESSLY DISCLAIMS ALL
** WARRANTIES OF ANY KIND (WHEHTER EXPRESS, IMPLIED, STATUTORY OR OTHERWISE) IN CONNECTION
** WITH THE LICENSED SOFTWARE OR ANY OTHER ASPECT OF THIS AGREEMENT, INCLUDING, WITHOUT
** LIMITATION ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
** TITLE OR NON-INFRINGEMENT OF THIRD PARTY RIGHTS, AND ANY WARRANTIES THAT MAY ARISE
** FROM COURSE OF DEALING, COURSE OF PERFORMANCE OR USAGE OF TRADE.  ATMEL WILL HAVE
** NO OBLIGATION UNDER THIS AGREEMENT TO CORRECT ANY BUGS, DEFECTS OR ERRORS IN
** THE LICENSED SOFTWARE, PROVIDE ANY UPDATES, UPGRADES OR NEW RELEASES OF THE LICENSED SOFTWARE,
** OR OTHERWISE PROVIDE ANY SUPPORT OR MAINTENANCE FOR THE LICENSED SOFTWARE.
**
** 6.  	Export.  Licensee will comply with all applicable laws and regulations of all
** relevant jurisdictions in connection with its activities related to the Licensed Software.
** Without limitation of the foregoing, Licensee acknowledges that certain laws
** and regulations of the United States and other jurisdictions may pertain to the export
** and re-export of the Licensed Software, and Licensee will not export or re-export
** any Licensed Software in any form without the appropriate governmental approvals,
** or otherwise in violation of any such laws or regulations.
**
** 7.	Termination.  The license will automatically terminate if Licensee fails to comply
** with any of the terms and conditions of the license including, without limitation
** the confidentiality obligation or the obligations set forth in Sections 1, 2, 6, 7, 10
** and 11 herein. Upon termination for any reason, Licensee will immediately destroy
** or return to Atmel all whole or partial copies of the Licensed Software.
**
** 8.	High Risk Activities. LICENSEE ACKNOWLEDGES AND AGREES THAT THE LICENSED SOFTWARE
** IS NOT DESIGNED OR APPROVED FOR, AND WILL NOT BE INCORPORATED (WITHOUT THE EXPRESS WRITTEN
** APPROVAL OF AN OFFICER OF ATMEL) INTO, ANY PRODUCTS THAT ARE USED OR DESIGNED TO BE USED
** IN CONNECTION WITH ANY ACTIVITIES WHERE THE FAILURE OF SUCH PRODUCTS COULD REASONABLY
** BE EXPECTED TO RESULT IN DEATH, BODILY INJURY, OR SEVERE PHYSICAL OR ENVIRONMENTAL DAMAGE
** ("HIGH RISK ACTIVITIES").  IN NO EVENT WILL ATMEL HAVE ANY LIABILITY TO LICENSEE
** OR ANY THIRD PARTY ARISING OUT OF OR RELATED TO ANY USE OF LICENSED SOFTWARE IN CONNECTION
** WITH HIGH RISK ACTIVITIES, AND ATMEL HEREBY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF
** FITNESS FOR ANY HIGH RISK ACTIVITIES.
**
** 9.  	LIMITATION OF LIABILITY.  TO THE EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL
** ATMEL BE LIABLE TO LICENSEE OR ANY THIRD PARTY (WHETHER SUCH LIABILITY IS BASED ON CONTRACT,
** NEGLIGENCE, STRICT LIABILITY, OTHER TORT THEORY, CONTRIBUTION, BREACH OF WARRANTY,
** OR OTHER LEGAL OR EQUITABLE THEORY) FOR ANY SPECIAL, INDIRECT, INCIDENTAL, EXEMPLARY,
** PUNITIVE OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES FOR LOSS OF PROFITS,
** LOSS OR INTERRUPTION OF BUSINESS, OR LOSS OF DATA, ARISING OUT OF OR RELATING TO
** THE LICENSED SOFTWARE OR ANY OTHER ASPECT OF THIS AGREEMENT, EVEN IF ATMEL has been advised
** of or should have known of the possibility of such damages.
**
** IN NO EVENT WILL ATMEL’S TOTAL LIABILITY ARISING OUT OF OR RELATED TO THE LICENSED SOFTWARE
** OR ANY OTHER ASPECT OF THIS AGREEMENT (WHETHER UNDER CONTRACT, NEGLIGENCE, STRICT LIABILITY,
** CONTRIBUTION, BREACH OF WARRANTY, OR OTHER LEGAL OR EQUITABLE THEORY) EXCEED THE GREATER OF
** (A) THE AGGREGATE OF ALL LICENSE FEES PAID BY LICENSEE TO ATMEL FOR THE LICENSED SOFTWARE, OR
** (B) ONE THOUSAND DOLLARS ($1,000). WITHOUT LIMITING THE FOREGOING,
** AND Notwithstanding any provision herein to the contrary, ATMEL will not be liable for
** ANY costs of PROCURING SUBSTITUTE GOODS, SERVICES OR TECHNOLOGY under any circumstances.
**
** Each Party acknowledges that THE OTHER PARTY has entered into this agreement in reliance
** on the limitations of liability, DISCLAIMERS OF WARRANTIES, EXCLUSION OF DAMAGES
** AND EXCLUSIVE REMEDIES contained in this AGREEMENT, AND THAT EACH OF THE FOREGOING PROVISIONS FORMS
** AN ESSENTIAL AND fundamental part of the basis of the bargain BETWEEN THE PARTIES,
** WITHOUT WHICH SUCH the other Party would not have entered into this Agreement.
** EACH PARTY AGREES THAT SUCH PROVISIONS WILL SURVIVE AND APPLY NOTWITHSTANDING ANY
** FAILURE OF ESSENTIAL PURPOSE OF ANY LIMITED REMEDY OR LIMITATION OF LIABILITY.
**
** 10.  	Governing Law; Dispute Resolution. This Agreement is to be construed in accordance
** with and governed by the internal laws of the State of California (as permitted by Section 1646.5
** of the California Civil Code or any similar successor provision), without giving effect
** to any choice of law rule that would cause the application of the laws of any jurisdiction
** other than the internal laws of the State of California to the rights and duties of the parties.
** This Agreement will not be governed by the U.N. Convention on the Sale of Goods,
** the application of which is expressly excluded. Except for actions for injunctive
** or other equitable relief, which may be brought in any court of competent jurisdiction,
** all disputes arising out of or related to this Agreement will be subject to the exclusive
** jurisdiction of the California state courts in Santa Clara County, California,
** or if there is exclusive federal jurisdiction, the United States District Court for
** the Northern District of California, and the Parties hereby consent to, and agree to submit to,
** the personal and exclusive jurisdiction and venue of such courts.
**
** 11. 	General. Licensee will not, and will have no right to, assign, delegate or otherwise
** transfer (whether voluntarily, by operation of law or otherwise) this Agreement or any of
** its rights or obligations hereunder to any third party without the prior written consent
** of Atmel, and any purported assignment, delegation or other transfer without such consent
** will have no force or effect. Subject to the foregoing, this Agreement will be binding upon
** and will inure to the benefit of the parties and their respective successors and permitted assigns.
** No failure of either party to enforce any right under this Agreement will be deemed a waiver
** of such right or any other right under this Agreement. Any waiver by a party of a breach
** of any provision of this Agreement by the other party hereunder will not be deemed to be
** a waiver of any subsequent breach of such provision or a waiver of any breach of any other
** provision of this Agreement.
** This Agreement may not be superseded, modified, or amended except in a writing signed by an officer
** of each party. If any provision of this Agreement is determined to be invalid, illegal
** or otherwise unenforceable, such provision will be enforced to the extent possible consistent
** with the intent of the parties, and the remaining provisions of this Agreement will remain in
** full force and effect. This Agreement will be fairly interpreted in accordance with its terms
** and without any strict construction against either party because it was drafted by such party
** or for any other reason. This Agreement will constitute the entire agreement between the parties
** relating to the subject matter hereof, and expressly supersedes and replaces all prior
** and contemporaneous agreements, proposals, quotations, negotiations and communications, written
** or oral, between the parties relating to such subject matter.
**
**
** Software Author: Timesys Corporation (www.timesys.com)
**
** Summary: Weather XML reader
**
****************************************************************************/

#include "weatherxmlcontenthandler.h"
#include <QtCore>
#include <QtXml>

#include <iostream>

/**
 *@note: if it is currently night, day 2-5 forecast icons will be for the night forecast.
 */

bool WeatherXmlContentHandler::startDocument()
{
    minimumTemps.clear();
    maximumTemps.clear();
    weatherIconLocations.clear();
    mode = "";
    humidity = -1;
    precipitation = -1;
    isNight = false;
    weatherIconLocations.clear();
    weatherForecastDescription = "";
    //Do not reset stateShortName since this is needed after google weather API xml parse.
    //stateShortName = "";
    latitudes.clear();
    longitudes.clear();
    dewPoint = -1;
    sustainedWind = -1;

    return true;
}

/**
 * @brief WeatherXmlContentHandler::startElement
 * @param namespaceURI
 * @param localName
 * @param qName
 * @param atts
 * @return
 *
 * Contains logic for parsing Google Weather API 3.0 XML feed and weather.gov XML feed.
 *
 * Parses latitude and longitude coordinates from google weather XML feed, and all other parameters
 * below from weather.gov XML feed.
 *
 * @todo debug print commented couts below.
 */
bool WeatherXmlContentHandler::startElement(const QString & namespaceURI, const QString & localName,
                    const QString & qName, const QXmlAttributes & atts )
{
//    std::cout << "Read Start Tag : " << localName.toStdString()<< std::endl;
//    std::cout << "Tag Attributes: " << std::endl;

    if(!localName.compare("temperature") && atts.length() > 0 && !atts.value(0).compare("minimum"))
        mode = QString("minimum");
    else if(!localName.compare("temperature") && atts.length() > 0 && !atts.value(0).compare("maximum"))
        mode = QString("maximum");
    else if(!localName.compare("humidity"))
        mode = QString("humidity");
    else if(!localName.compare("probability-of-precipitation"))
        mode = QString("precipitation");
    else if(!localName.compare("weather-conditions"))
    {
        if (!isNight && weatherIconLocations.size() < 5)
        {
            if (weatherIconLocations.size() == 0)
                weatherForecastDescription = atts.value(0);

            appendIconLocation(atts.value(0));
        }
        isNight = !isNight;
    }
    else if(!localName.compare("wind-speed") && atts.length() > 0 && !atts.value(0).compare("sustained"))
        mode = QString("sustained_wind");
    else if(!localName.compare("temperature") && atts.length() > 0 && !atts.value(0).compare("dew point"))
        mode = QString("dewpoint");

    else if(!localName.compare("lat"))
        mode = QString("latitude");
    else if(!localName.compare("lng"))
        mode = QString("longitude");
    else if(!localName.compare("address_component"))
        mode = QString("address_component");
    else if(!mode.compare("address_component") && !localName.compare("short_name") )
        mode = QString("state-short-name");

//    for(int index = 0 ; index<atts.length();index++)
//    {
//        std::cout << atts.type(index).toStdString()<<"="
//      <<atts.value(index).toStdString()<< std::endl;
//    }

//    std::cout << "------------------------" << std::endl;

    return true;

}

void WeatherXmlContentHandler::appendIconLocation( const QString & weatherDescription )
{
    if (weatherDescription.contains("Freezing", Qt::CaseInsensitive) ||
            weatherDescription.contains("Snow", Qt::CaseInsensitive) ||
            weatherDescription.contains("Flurr", Qt::CaseInsensitive) ||
            weatherDescription.contains("Sleet", Qt::CaseInsensitive) ||
            weatherDescription.contains("Wintry", Qt::CaseInsensitive) )
    {
        weatherIconLocations.append(SNOW_ICON_LOCATION);
    }
    else if ( weatherDescription.contains("Thunder", Qt::CaseInsensitive) ||
              weatherDescription.contains("Storm", Qt::CaseInsensitive) )
    {
        weatherIconLocations.append(STORM_ICON_LOCATION);
    }
    else if ( weatherDescription.contains("Rain", Qt::CaseInsensitive) )
    {
        weatherIconLocations.append(RAIN_ICON_LOCATION);
    }
    else if ( weatherDescription.contains("Showers", Qt::CaseInsensitive) ||
              weatherDescription.contains("Sprinkle", Qt::CaseInsensitive) ||
              weatherDescription.contains("Drizzle", Qt::CaseInsensitive) )
    {
        weatherIconLocations.append(SHOWERS_ICON_LOCATION);
    }
    else if ( weatherDescription.contains("Cloudy", Qt::CaseInsensitive) ||
              weatherDescription.contains("Partly Sunny", Qt::CaseInsensitive) ||
              weatherDescription.contains("Overcast", Qt::CaseInsensitive) )
    {
        weatherIconLocations.append(CLOUDS_ICON_LOCATION);
    }
    else
    {
        weatherIconLocations.append(SUN_ICON_LOCATION);
    }
}

void WeatherXmlContentHandler::setParameter( QList<int>* param, const QString & ch, int maxParamSize )
{
    bool ok;
    int value = ch.toInt(&ok);
    if (ok && param->size() < maxParamSize)
        param->append(value);
    if (param->size() == maxParamSize)
        mode = "";
}

void WeatherXmlContentHandler::setParameter( QList<double>* param, const QString & ch, int maxParamSize )
{
    bool ok;
    double value = ch.toDouble(&ok);
    if (ok && param->size() < maxParamSize)
        param->append(value);
    if (param->size() == maxParamSize)
        mode = "";
}

void WeatherXmlContentHandler::setParameter( int* param, const QString & ch )
{
    bool ok;
    int value  = ch.toInt(&ok);
    if (ok)
    {
        *param = value;
        mode = "";
    }
}

void WeatherXmlContentHandler::setParameter( QString * param, const QString & ch )
{
    *param = ch;
    mode = "";
}


bool WeatherXmlContentHandler::characters ( const QString & ch )
{
//    std::cout << "Characters: " << ch.toStdString() << std::endl;

    //Store 5 days of minimum temps.
    if (! mode.compare("minimum"))
        setParameter( &minimumTemps, ch, 5 );

    //Store 5 days of maximum temps.
    else if (! mode.compare("maximum"))
        setParameter( &maximumTemps, ch, 5 );

    //Store current humidity.
    else if (! mode.compare("humidity"))
        setParameter( &humidity, ch );

    //Store current precipitation chance.
    else if (! mode.compare("precipitation"))
        setParameter( &precipitation, ch );

    //Store latitude coordinates of current zip code.
    else if (! mode.compare("latitude"))
        setParameter( &latitudes, ch, 1 );

    //Store longitude coordinates of current zip code.
    else if (! mode.compare("longitude"))
        setParameter( &longitudes, ch, 1 );

    //Store current dewpoint.
    else if (! mode.compare("dewpoint"))
        setParameter( &dewPoint, ch );

    //Store current wind speed.
    else if (!mode.compare("sustained_wind"))
        setParameter( &sustainedWind, ch );

    //Store state as 2 letter abbreviation.
    else if (!mode.compare("state-short-name") && ch.size() == 2 && ch.compare("US"))
        setParameter( &stateShortName, ch );

    //After the state is parsed the only other information that patches the parse parameters is 'US'.
    //Reset the mode since we do not want to store 'US'.
    else if (!mode.compare("state-short-name") && !ch.compare("US"))
        mode = "";

    return true;
}
